VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CEventTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event PercentDone(ByVal Percent As Single, ByRef lbCancel As Boolean)

'Module level variables passed in from caller
Private mfDuration    As Single
Private mfMinInterval As Single

'Module level variable to pass to Timer routines
Private mlTimer       As Long

Public Sub StartTask(ByVal afDuration As Single, _
    ByVal afMinInterval As Single)

    'Save values passed in from the caller
    mfDuration = afDuration
    mfMinInterval = afMinInterval
    
    'Inform the user
    MsgBox "When you press OK, the timer will count down" + vbCrLf + _
           "from two seconds before the Long Task starts." + _
            vbCrLf + vbCrLf + _
           "Note how code in the Form starts, stops/starts.", _
            vbOKOnly, "Enabling timer"
    
    'Start the timer
    StartTimer Me
    
End Sub

Public Sub LongTask()
    
    Dim lfThreshold As Single
    Dim lfStart     As Single
    Dim lbCancel    As Boolean
    
    'Use the VB timer function, returns
    'number of seconds since midnight
    lfStart = Timer
    lfThreshold = mfMinInterval
    
    Do While Timer < (lfStart + mfDuration)
        If Timer > (lfStart + lfThreshold) Then
            RaiseEvent PercentDone(lfThreshold / mfDuration, lbCancel)
            Debug.Print lfThreshold / mfDuration
            'Check to see if the operation was Canceled.
            If lbCancel Then Exit Sub
            
            lfThreshold = lfThreshold + mfMinInterval
        End If
    Loop

End Sub




